X-Git-Url: https://git.ladys.computer/WWW/blobdiff_plain/ad249fcdf0bf13bc6abaa97a80fc63b8de002601..HEAD:/GNUmakefile?ds=inline

diff --git a/GNUmakefile b/GNUmakefile
index 93fb66e..8486bff 100644
--- a/GNUmakefile
+++ b/GNUmakefile
@@ -1,44 +1,53 @@
 SHELL = /bin/sh
 
-# © 2023 Lady [@ Lady’s Computer].
+# © 2023–2024 Lady [@ Lady’s Computer].
 #
 # This Source Code Form is subject to the terms of the Mozilla Public
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at https://mozilla.org/MPL/2.0/.
 
-# This Makefile requires rsync 3 or newer.
-RSYNC = rsync
-RSYNC_FLAGS = -Oclmrtvz
-RSYNC_OPTIONS =
-RSYNC_FILTER = .rsync-filter
+SRCDIR := sources
+BUILDDIR := build
+BUILDTARGET := .grass
+DESTDIR := public
 
-SOURCE_CHARSET = utf-8-mac
+SHUSHE := .⛩📰
+SHUSHEOPTS := SRCDIR='$(SRCDIR)' INCLUDEDIR='$(SRCDIR)/{include}' EXTRAPARSERS='$(wildcard parsers/*.xslt)' EXTRATRANSFORMS='$(wildcard transforms/*.xslt)'
 
-DESTINATION_HOST = computer
-DESTINATION_PATH = lady/www
-DESTINATION = $(DESTINATION_HOST):$(DESTINATION_PATH)
-DESTINATION_CHARSET = utf-8
+YSEME := .👥📤
+YSEMEOPTS := BUILDTARGET='.grass' DESTDIR='$(DESTDIR)' SERVERPATH='lady/www'
 
-build:
-# Put any necessary build scripts in here!
-	touch .grass
+# ━ § Call out to ⛩📰 书社 ━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━
 
-ensure-build:
-	@if [ ! -f .grass ]; then echo 'Error: The website has not been built yet!' >&2; echo 'Run `make` before syncing.' >&2; exit 1; fi
-	@if buildtime=$$(stat -f '%m' .grass) && committime=$$(git log -1 --format='%ct' | awk '{print $$NF}') && [ "$$committime" -gt "$$buildtime" ]; then echo 'Error: A commit was made after the last build!' >&2; echo 'Run `make` before syncing.' >&2; exit 1; fi
+build : $(SHUSHE)/GNUmakefile prebuild
+	@for publicfile in $(patsubst %,"%",$(wildcard $(DESTDIR)/*)); do if git check-ignore -q "$$publicfile"; then rm -rf "$$publicfile"; fi; done
+	@$(MAKE) -f '$<' install $(SHUSHEOPTS)
+	@touch '$(BUILDTARGET)'
 
-ensure-branch-up-to-date:
-	git fetch
-	@if ! git merge-base --is-ancestor @{u} HEAD; then echo 'Error: This branch is currently out‐of‐date!' >&2; echo 'Pull in changes with `git pull` before syncing.' >&2; exit 1; fi
+prebuild : $(SHUSHE)/GNUmakefile
+	@$(MAKE) -f '$<' $(SHUSHEOPTS)
 
-ensure-clean:
-	@if output=$$(git status --porcelain) && [ ! -z "$$output" ]; then echo 'Error: There are uncommitted changes!' >&2; echo 'Commit changes and run `make` before syncing.' >&2; exit 1; fi
+list : $(SHUSHE)/GNUmakefile
+	@$(MAKE) -f '$<' $@ $(SHUSHEOPTS)
 
-dry-sync: ensure-clean ensure-branch-up-to-date ensure-build
-	$(RSYNC) $(RSYNC_FLAGS) --del --dry-run --filter=". $(RSYNC_FILTER)" --iconv=$(SOURCE_CHARSET),$(DESTINATION_CHARSET) $(RSYNC_OPTIONS) . $(DESTINATION)
+$(BUILDDIR)/% $(DESTDIR)/% : $(SHUSHE)/GNUmakefile
+	@$(MAKE) -f '$<' $@ $(SHUSHEOPTS)
 
-sync: ensure-clean ensure-branch-up-to-date ensure-build
-	$(RSYNC) $(RSYNC_FLAGS) --del --filter=". $(RSYNC_FILTER)" --iconv=$(SOURCE_CHARSET),$(DESTINATION_CHARSET) $(RSYNC_OPTIONS) . $(DESTINATION)
-	git push --force
+# ━ § Call out to 👥📤 Yseme ━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━
 
-.PHONY: build dry-sync ensure-branch-up-to-date ensure-build ensure-clean sync;
+dry-sync sync : $(YSEME)/GNUmakefile
+	$(MAKE) -f '$<' $@ $(YSEMEOPTS)
+
+# ━ § Special targets ━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━
+
+gone :
+	@for publicfile in $(patsubst %,"%",$(wildcard $(DESTDIR)/*)); do if git check-ignore -q "$$publicfile"; then rm -rf "$$publicfile"; fi; done
+
+FORCE : ;
+
+.PHONY : FORCE build dry-sync gone list prebuild sync ;
+
+# ━ § Make·file targets ━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━
+
+$(SHUSHE)/GNUmakefile $(YSEME)/GNUmakefile : %/GNUmakefile : FORCE
+	git submodule update --init '$*'